<?php

// function draw_bar
// $type,    - Aufgeklappt (Level 1,2)
// $total,   - Basiswert (100%)
// $amount,  - Anzahl
// $num      - Nummer (div)
// $label    - Beschriftung
// $stretch  - Streckung des Bar
// $factor   - Faktor um die Prozentanzeige zu erhhen
// $accuracy - Genauigkeit der Rundung
function draw_bar($type, $total, $amount, $num, $label=false, $stretch=1, $factor=1, $accuracy=2) {

  if($label == false) {
    $label = $num;
  }

  if($total != 0) {
    $perc = round($amount / $total * 100, 2);
    if($factor != 1) $true_perc = round(($amount / $factor) / $total * 100, $accuracy);
    else $true_perc = $perc;
  } else {
    $total = 0;
  }

  echo "\n<tr>\n";
  if($type == 1) {
    echo "<td width=\"15\"><a href=\"javascript:void(0)\" onclick=\"toggle('".$num."')\"><img src=\"ar.gif\" border=\"0\" id=\"arrow".$num."\"  alt=\"\" /></a></td>\n";
    echo "<td style=\"background-image:url('bg.png');cursor:pointer;\" onclick=\"toggle('".$num."')\"><img src=\"bg1.png\" align=\"right\" alt=\"\" />".$label.":&nbsp;</td>\n";

  } else {
    echo "<td width=\"15\"></td>\n";
    echo "<td style=\"background-image:url('bg.png');\"><img src=\"bg1.png\" align=\"right\" alt=\"\" />".$label.":&nbsp;</td>\n";
  }


  echo "<td width=\"350\" class=\"small\">";

  $used = $perc * $stretch;
  echo "<img src=\"bar.gif\" width=\"".(int)$used."\" height=\"10\" alt=\"\" />";

  $unused = (100 - $perc) * $stretch;
  if($factor != 1) {
    $unused = $unused - 50;
    echo "<img src=\"bar_.gif\" width=\"".(int)$unused."\" height=\"10\" alt=\"\" />";
    echo "<img src=\"factor.png\" width=\"20\" height=\"10\" alt=\"\" />";
    echo "<img src=\"bar_.gif\" width=\"30\" height=\"10\" alt=\"\" />";
  } else {
    echo "<img src=\"bar_.gif\" width=\"".(int)$unused."\" height=\"10\" alt=\"\" />";
  }
//Mostrar valores en porcentaje de la poblacion 
  echo " ".$true_perc."% (".$amount / $factor.")</td>\n</tr>\n";
//Mostrar valores cada 1.000 habitantes de poblacion 
//  echo " ". 1000 * $true_perc."/100.000 hab (".$amount / $factor.")</td>\n</tr>\n";

}

// compares two arrays
function cmp($a, $b) {

  if($a['value'] == $b['value']) {
    return 0;
  }
  return ($a['value'] > $b['value']) ? -1 : 1;
}

?>