<?php


function calculate_rgb( $value, $max, $min ) {
  $tolerance = $max - $min;

  $multiplier = 255 / $tolerance;

  return round(($value - $min) * $multiplier,0);
}

set_time_limit($config['image_time_limit']);

//$file = "./postcode2_big_clear2.png";
$file = "./espana.png";

$arr = GetImageSize($file);
switch ($arr[2]) {
  case 1: $type = "gif"; break;
  case 2: $type = "jpeg"; break;
  case 3: $type = "png"; break;
}

// size of the original image
$size_width  = $arr[0];
$size_height = $arr[1];

if($size_width != 1200 OR
   $size_height != 798) {
  echo "El tamao de la imagen debe ser: {$size_width}px x {$size_height}px!";
}


// size of the output
if (!empty($_REQUEST['ratio']) AND is_numeric($_REQUEST['ratio'])) {

  $ratio = $_REQUEST['ratio'];

  if ($ratio > 1) {
    $ratio = 1;
  } elseif ($ratio < 0) {
    $ratio = 0.25;
  } else {
    $ratio = $_REQUEST['ratio'];
  }

} else {
  $ratio = 0.5;
}


if ($type == "gif")  {
  $image = ImageCreateFromGIF($file);
} elseif ($type == "jpeg") {
  $image = ImageCreateFromJPEG($file);
} elseif ($type == "png") {
  $image = ImageCreateFromPNG($file);
}

$white = ImageColorAllocate($image, 255,255,255);
$black = ImageColorAllocate($image, 0,0,255);
$red = ImageColorAllocate($image, 255,0,0);
$green = ImageColorAllocate($image, 0,255,0);

// there is a pixel at the top left with the user border color
$colorindex = ImageColorAt($image, 0, 0);
$colorrgb = ImageColorsForIndex($image, $colorindex);
$border = ImageColorAllocate($image, $colorrgb['red'], $colorrgb['green'], $colorrgb['blue']);

                      //x - y
$points["01"] = array(688, 91);
$points["02"] = array(739, 457);
$points["03"] = array(840, 481);
$points["04"] = array(721, 604);
$points["05"] = array(533, 301);
$points["06"] = array(436, 465);
$points["07"] = array(1080, 360, 1164, 332, 989, 434);
$points["08"] = array(1006, 189);
$points["09"] = array(618, 132);
$points["10"] = array(447, 364);
$points["11"] = array(460, 663);
$points["12"] = array(861, 337);
$points["13"] = array(608, 446);
$points["14"] = array(539, 527);
$points["15"] = array(309, 57);
$points["16"] = array(718, 355);
$points["17"] = array(1065, 146);
$points["18"] = array(633, 600);
$points["19"] = array(681, 271);
$points["20"] = array(721, 65);
$points["21"] = array(389, 563);
$points["22"] = array(866, 147);
$points["23"] = array(626, 523);
$points["24"] = array(461, 106);
$points["25"] = array(944, 162);
$points["26"] = array(686, 137);
$points["27"] = array(382, 70);
$points["28"] = array(604, 298);
$points["29"] = array(543, 627);
$points["30"] = array(774, 536);
$points["31"] = array(748, 92);
$points["32"] = array(362, 146);
$points["33"] = array(461, 48);
$points["34"] = array(558, 143);
$points["35"] = array(353, 679, 325, 735, 195, 762);
$points["36"] = array(311, 99);
$points["37"] = array(453, 264);
$points["38"] = array(118, 735, 71, 753, 23, 700);
$points["39"] = array(590, 60);
$points["40"] = array( 590, 238);
$points["41"] = array(475, 578);
$points["42"] = array(685, 193);
$points["43"] = array( 914,253);
$points["44"] = array(802, 289);
$points["45"] = array(569, 354);
$points["46"] = array(827, 412);
$points["47"] = array( 540, 200);
$points["48"] = array(674, 58);
$points["49"] = array(477, 186);
$points["50"] = array(787, 214);
//$points["51"] = array(149, 627);
//$points["52"] = array( 45, 654);

// DEBUG: flood fill of all areas
/*
foreach($points as $key => $value) {

  if (!($key % 10)) {
    $counter = 1;
  } else {
    $counter++;
  }

  for($i=0; $i<count($value); $i = $i+2) {

    $x = $value[$i];
    $y = $value[$i+1];

    imagefilltoborder($image, $x, $y, $border, ImageColorAllocate($image, $counter*15,$counter*15,$counter*15));
  }
}
*/

$undefined_postcodes = array('00' => 1);

$total = 0;

for($i=0; $i<10; $i++) {
  for($j=0; $j<10; $j++) {

    if (isset($postcode_array[$i][$j])) {
      $total += count($postcode_array[$i][$j]);
    }

  }
}
# total: amount of all customers

$biggest_amount = 0;

for($i=0; $i<10; $i++) {
  for($j=0; $j<10; $j++) {
    $amount = 0;

    for($k=0; $k<10; $k++) {

      if (isset($postcode_array[$i][$k])) {
        $amount += count($postcode_array[$i][$k]);
      }

    }
    if(!isset($undefined_postcodes[$i.$j])) {

      $customers = count($postcode_array[$i][$j]);

      if(!isset($smallest_amount)) { $smallest_amount = $customers; }

      if($customers < $smallest_amount) { $smallest_amount = $customers; }
      if($customers > $biggest_amount)  { $biggest_amount  = $customers; }
    }
  }
}


#echo "Min: $smallest_amount - Max: $biggest_amount - Factor: $stretch_factor<br><br>";

for($i=0; $i<10; $i++) {

  for($j=0; $j<10; $j++) {
    $amount = 0;

    if(!isset($undefined_postcodes[$i.$j])) {


      $value = $points[$i.$j];

      for($n=0; $n<count($value); $n = $n+2) {

        $x = $value[$n];
        $y = $value[$n+1];

        $customers = count($postcode_array[$i][$j]);

        if ($config['image_color_red_black'] == true) {

          imagefilltoborder($image, $x, $y, $border,
            ImageColorAllocate($image, calculate_rgb($customers, $biggest_amount, $smallest_amount), 0, 0));

        } else {

          imagefilltoborder($image, $x, $y, $border,
            ImageColorAllocate($image, 255,
                                       255 - calculate_rgb($customers, $biggest_amount, $smallest_amount),
                                       255 - calculate_rgb($customers, $biggest_amount, $smallest_amount)));

        } //END: if ($config['image_color_red_black'] == true)

      }


    }
  }
}


// replaces gray borders whith red color
/*
if ($config['image_color_red_black'] == false) {

  // change it to red
  imagecolorset($image, $colorindex, 255, 0, 0);
}
*/

// zooms the image
$zoomed_width  = $size_width * $ratio;
$zoomed_height = $size_height * $ratio;
$zoomed_image = ImageCreateTrueColor($zoomed_width, $zoomed_height + 50);
ImageCopyResized($zoomed_image, $image, 0, 0, 0, 0, $zoomed_width, $zoomed_height, $size_width, $size_height);
// makes the upper frame (50px) white, too
ImageFilledRectangle($zoomed_image, 0, $zoomed_height, $zoomed_width, $zoomed_height + 50, $white);


// gets best font size
if     ($ratio == 1)      { $font_size = 5; }
elseif ($ratio >= 0.75)   { $font_size = 4; }
elseif ($ratio >= 0.5)    { $font_size = 3; }
elseif ($ratio >= 0.25)   { $font_size = 2; }
else                      { $font_size = 1; }

// shows the points on the map
foreach($points as $key => $value) {

  for($i=0; $i<sizeof($value); $i = $i+2) {

    $x = $value[$i] * $ratio;
    $y = $value[$i+1] * $ratio;

    if ($config['image_color_red_black'] == true) {
      imageString($zoomed_image, $font_size, $x, $y, "$key" , $white);
    } else {
      imageString($zoomed_image, $font_size, $x, $y, "$key" , $black);
    }


  }
}


if ($config['image_color_red_black'] == true) {

  // shows caption:
  ImageFilledRectangle($zoomed_image, 5, $zoomed_height+5, 30, $zoomed_height+20,
    ImageColorAllocate($zoomed_image, calculate_rgb($smallest_amount, $biggest_amount, $smallest_amount), 0, 0));

  ImageString($zoomed_image, $font_size, 40, $zoomed_height+5, "Min: $smallest_amount Clientes", $black);

  // shows caption:
  ImageFilledRectangle($zoomed_image, 5, $zoomed_height+25, 30, $zoomed_height+40,
    ImageColorAllocate($zoomed_image, calculate_rgb($biggest_amount, $biggest_amount, $smallest_amount), 0, 0));

  ImageString($zoomed_image, $font_size, 40, $zoomed_height+25, "Max: $biggest_amount Clientes" , $black);


} else {

  // shows caption (border):
  ImageFilledRectangle($zoomed_image, 4, $zoomed_height+4, 32, $zoomed_height+22,
    ImageColorAllocate($zoomed_image, 0, 0, 0));

  // shows caption:
  ImageFilledRectangle($zoomed_image, 5, $zoomed_height+5, 30, $zoomed_height+20,
    ImageColorAllocate($zoomed_image, 255,
                                      255 - calculate_rgb($smallest_amount, $biggest_amount, $smallest_amount),
                                      255 - calculate_rgb($smallest_amount, $biggest_amount, $smallest_amount)));


  ImageString($zoomed_image, $font_size, 40, $zoomed_height+5, "Min: $smallest_amount Clientes", $black);

  // shows caption (border):
  ImageFilledRectangle($zoomed_image, 4, $zoomed_height+26, 32, $zoomed_height+42,
    ImageColorAllocate($zoomed_image, 0, 0, 0));

  // shows caption:
  ImageFilledRectangle($zoomed_image, 5, $zoomed_height+27, 30, $zoomed_height+40,
    ImageColorAllocate($zoomed_image, 255,
                                      255 - calculate_rgb($biggest_amount, $biggest_amount, $smallest_amount),
                                      255 - calculate_rgb($biggest_amount, $biggest_amount, $smallest_amount)));

  ImageString($zoomed_image, $font_size, 40, $zoomed_height+27, "Max: $biggest_amount Clientes" , $black);



}


// everything was right
if (!headers_sent()) {

  header("Cache-Control: max-age=86400");
  header("Expires: ".date("D, d M Y H:i:s", time() + 86400));

  header("Content-type: image/png");
  imagePNG($zoomed_image);

}


imagedestroy($image);
imagedestroy($zoomed_image);

?>